// exam.cpp : Defines the entry point for the console application.
//

#include	<conio.h>
#include	<stdio.h>
#include	<tchar.h>
#include	<ctype.h>
#include	<windows.h>

#include	"brd.h"
#include	"ctrlstrm.h"
#include	"ctrladmpro.h"

#include	"ctrlttlin.h"
#include	"ctrlttlout.h"
#include	"ctrldio2in.h"

typedef struct 
{ 
	U32 aMODE;
	U32 aGEN;
	double aRATE;
	double aCLK;
	U32 aSYNCMODE;
	U32 aMASTER;
	U32 aSTARTMODE;

	U32	aBUFSIZE;

} DIO2_MU;

DIO2_MU g_MUParam =
{
	0,// aMODE;
	0,
	0,
	0,// aCLK;
	0,// aSYNCMODE;
	0,// aMASTER;
	0,// aSTARTMODE;

	4096

};


//=****************** ReadIni Prepare ******************
//=********************************************************
typedef struct { int isFloat; void *ptr; char title[16]; } TReadIniEntry;
static TReadIniEntry    iniEntry[] =
{
	{ 0, (void*)&g_MUParam.aMODE,      "MODE=" },
	{ 0, (void*)&g_MUParam.aGEN,      "GEN=" },
	{ 1, (void*)&g_MUParam.aRATE,      "RATE=" }, 
	{ 1, (void*)&g_MUParam.aCLK,      "CLK=" },
	{ 0, (void*)&g_MUParam.aMASTER,      "MASTER=" },
	{ 0, (void*)&g_MUParam.aSTARTMODE,      "START=" },

};

//=************************** ReadAdcIni ******************
//=********************************************************
void    ReadIniFile( char *pFileName )
{
    FILE    *stream;
    int     i;
    char    *endptr;

	char    g_str[128];

    //
    // Open INI File
    //
    stream = fopen( pFileName, "rt" );
    if( stream == NULL)
    {
        printf( "*** Can't find file \"%s\"\n", pFileName );
        return;
    }

    //
    // Read INI File
    //
    while( !feof(stream) )
    {
        size_t     len;

        if( fgets( g_str, 80, stream ) == 0 )
			break;

        for( i=0; i<sizeof(iniEntry)/sizeof(iniEntry[0]); i++ )
        {
            len = strlen( iniEntry[i].title );
            if( strncmp( g_str, iniEntry[i].title, len ) == 0)
            {
                if( iniEntry[i].isFloat )
                {
                    *(double*)iniEntry[i].ptr  = (double)strtod( g_str+len, &endptr );
                    printf( "%11s %.1f\n", iniEntry[i].title, *(double*)iniEntry[i].ptr );
                }
                else
                {
                    int     base = 10;
                    char    *s = g_str+len;
                  
                    while (isspace(*s)) s++;
                    if( (s[0]=='0') && ((s[1]=='x') || (s[1]=='X')) )
                        base = 16;
                    *(SINT32*)iniEntry[i].ptr = strtoul( g_str+len, &endptr, base );
                    printf( "%11s %-#8lx (%ld)\n", iniEntry[i].title, *(int*)iniEntry[i].ptr, *(int*)iniEntry[i].ptr );
                }
            }
        }
    }
    fclose(stream);
}

BRD_Handle hBrd = 0;
BRD_Handle g_hTtlIn = 0;
BRD_Handle g_hTtlOut = 0;

void SetExamParam()
{
	S32 err = 0;
	BRD_ClkMode clkmode;
	BRD_StartMode startmode;	
	
	err = BRD_ctrl( g_hTtlOut, 0, BRDctrl_TTLOUT_SETMASTER, &g_MUParam.aMASTER );
	err &= BRD_ctrl( g_hTtlIn, 0, BRDctrl_TTLIN_SETMASTER, &g_MUParam.aMASTER );	
	
	if( err < 0 )
		exit( 1 );

	clkmode.src = BRDclks_TTLOUT;// TTLOUT 
	clkmode.value = 1;// always 1

	err = BRD_ctrl( g_hTtlIn, 0, BRDctrl_TTLIN_SETCLKMODE, &clkmode );

 	clkmode.src = g_MUParam.aGEN;
	clkmode.value = g_MUParam.aCLK;

	err &= BRD_ctrl( g_hTtlOut, 0, BRDctrl_TTLOUT_SETCLKMODE, &clkmode );
	
	if( err < 0 )
		exit( 1 );

	double inRate = 1;//Rate is 1
	err = BRD_ctrl( g_hTtlIn, 0, BRDctrl_TTLIN_SETRATE, &inRate );
	
	err &= BRD_ctrl( g_hTtlOut, 0, BRDctrl_TTLOUT_SETRATE, &g_MUParam.aRATE );

	if( err < 0 )
		exit( 1 );

	startmode.startSrc = BRDclks_TTLOUT;							// Start source TTLOUT
	startmode.startInv = 0;							// Start inversion
	startmode.trigOn = 0;		// Trigger start mode on
	startmode.trigStopSrc = 0;						// Stop source for trigger start
	startmode.stopInv = 0;							// Stop inversion
	startmode.reStartMode = 0;						// Restart mode 				
	err = BRD_ctrl( g_hTtlIn, 0, BRDctrl_TTLIN_SETSTARTMODE, &startmode );

	startmode.startSrc = 0;							// Start source
	startmode.startInv = 0;							// Start inversion
	startmode.trigOn = 0;		// Trigger start mode on
	startmode.trigStopSrc = 0;						// Stop source for trigger start
	startmode.stopInv = 0;							// Stop inversion
	startmode.reStartMode = 0;						// Restart mode 
	err &= BRD_ctrl( g_hTtlOut, 0, BRDctrl_TTLOUT_SETSTARTMODE, &startmode );

	U32 flag = (g_MUParam.aSTARTMODE==2)?1:0;
	err = BRD_ctrl( g_hTtlIn, 0, BRDctrl_TTLIN_SETSYMBSYNC, &flag );

	if( err < 0 )
		exit( 1 );
}

int g_errCnt = 0;
int numBuf = 0;

int Random()
{
	int  = GetTickCount();
	srand(  );
	return ( << 8)+rand( );
}

int CheckBuffer( U32 *sInPtr, int samplesCnt)
{
	int curId = 0;
	int prewId = sInPtr[ 0 ] - 1;

	int skipLoop = 1;

	for(int i = 0; i < samplesCnt; i++)
	{
		curId = sInPtr[ i ];

		if( curId == 0xFFFFAABB )
		{
			//printf( "%d, NEW BUFFER:%d\n", i, ~sInPtr[ i+1 ] );
			i++;

			prewId = sInPtr[ i+1 ]-1;
			continue;
		}

		if( curId != prewId + 1 )
		{
			if (g_errCnt<16)
			{			
				printf( "%d error:0x%x 0x%x\n", i, curId, prewId + 1 );
			}
			g_errCnt++;
		}

		prewId = curId;
	}

	return 0;
}

int FillBuffer( U32 *sOutPtr, int n, int samplesCnt)
{
	sOutPtr[0] = 0xFFFFAABB;
	sOutPtr[1] = n;
		 
	int seed = Random();
	for(int i = 2; i < samplesCnt; i++)
	{
	  sOutPtr[i] = seed;
	  seed++;
	}
	//sOutPtr[0] = 0xFFFFAABB;
	//sOutPtr[1] = 0x00010000;
	//	 
	//for(int i = 2; i < samplesCnt; i++)
	//{
	//  sOutPtr[i] = (0xFFFF & 2*(i-2)+3)<<16 ;
	//  sOutPtr[i] |= (0xFFFF & 2*(i-2)+2);
	//}

	return 0;
}

void TestInOutCPU()
{
	printf("\nInput/Output by CPU\n");

	S32 samplesCnt = g_MUParam.aBUFSIZE;
	int g_bBufSize = g_MUParam.aBUFSIZE*sizeof(U32);
	
	U32 *sOutPtr = new U32[samplesCnt];
	U32 *sInPtr = new U32[samplesCnt];

	FillBuffer( sOutPtr, 0, samplesCnt );
	for(int i = 0; i < samplesCnt; i++)
	{
			sInPtr[i] = 0;

	}

	S32		status;

	printf("Hit any key to abort...\n");

	ULONG OutStatus = 0;
	ULONG InStatus = 0;
	ULONG Enable = 0;

	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_ENABLE, &Enable); //   TTLOUT
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLIN_ENABLE, &Enable); //   TTLOUT

	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_FIFORESET, NULL); //  FIFO TTLOUT
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_FIFORESET, NULL); //  FIFO TTLIN

	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_FIFOSTATUS, &InStatus);
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_FIFOSTATUS, &OutStatus);

	BRD_DataBuf data_buf_out;
	data_buf_out.pData = sOutPtr;
	data_buf_out.size = g_bBufSize;

	BRD_DataBuf data_buf_in;
	data_buf_in.pData = sInPtr;
	data_buf_in.size = g_bBufSize;

	ULONG flBreak = 0;

	Enable = 1;
	
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_FIFOSTATUS, &OutStatus);
	
	
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_ENABLE, &Enable); //   TTLIN
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_ENABLE, &Enable); //   TTLOUT

	int loop=0;
	do {
		status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_FIFOSTATUS, &OutStatus);
		
		if( OutStatus & 0x10 )
		{
			sOutPtr[ 0 ] = 0xFFFFAABB;
			sOutPtr[ 1 ] = loop;

			status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_PUTDATA, &data_buf_out);
			//printf( "a" );
		}

		status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_FIFOSTATUS, &InStatus);
		
		if(!(InStatus & 0x10))
		{
			status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_GETDATA, &data_buf_in);
			loop++;
		}
		CheckBuffer( sInPtr, samplesCnt );
		printf( "LOOP [0x%x] err:%d\r" , loop,g_errCnt );

	} while( !_kbhit());			
	
	

	getch();
	printf("Hit any key to exit\n");
	while( !_kbhit() );

	Enable = 0;
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_ENABLE, &Enable); //   TTLIN
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_ENABLE, &Enable); //   TTLOUT

	return;
}

#include	"ctrlstrm.h"

int g_IsSysMem = 0;

S32 TestInOutDMA()
{
	printf("\nInput/Output by DMA\n");
	S32		status;

	int g_bBufSize = g_MUParam.aBUFSIZE*sizeof(U32);
	int samplesCnt =  g_MUParam.aBUFSIZE;

	BRDctrl_StreamCBufAlloc buf_dscr_out;
	BRDctrl_StreamCBufAlloc buf_dscr_in;

	buf_dscr_out.dir = BRDstrm_DIR_OUT;
	buf_dscr_out.isCont = g_IsSysMem; // 0 -      , 1 -    
	buf_dscr_out.blkNum = 8;
	buf_dscr_out.blkSize = g_bBufSize;
	buf_dscr_out.ppBlk = new PVOID[buf_dscr_out.blkNum];
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr_out);
	
	U32* sOutPtr;
	U32* sInPtr;

	for( int n=0;n<8;n++)
	{
		sOutPtr = (U32*)buf_dscr_out.ppBlk[n];
		FillBuffer( sOutPtr, n, samplesCnt ); 

	}


	buf_dscr_in.dir = BRDstrm_DIR_IN;
	buf_dscr_in.isCont = g_IsSysMem; // 0 -      , 1 -    
	buf_dscr_in.blkNum = 8;
	buf_dscr_in.blkSize = g_bBufSize;
	buf_dscr_in.ppBlk = new PVOID[buf_dscr_in.blkNum];
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr_in);
	
	

	//      
	ULONG flag = BRDstrm_DRQ_HALF; //   - FIFO  
	
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_STREAM_SETDRQ, &flag);
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_STREAM_SETDRQ, &flag);

	//     
	ULONG tetrad;
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_GETSRCSTREAM, &tetrad); //     TTLOUT
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_STREAM_SETSRC, &tetrad);
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_GETSRCSTREAM, &tetrad); //     TTLIN
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_STREAM_SETSRC, &tetrad);

	ULONG Status = 0;
	ULONG Enable = 0;

	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_ENABLE, &Enable); //   TTLOUT
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_ENABLE, &Enable); //   TTLOUT

	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_FIFORESET, NULL); //  FIFO TTLOUT
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_FIFORESET, NULL); //  FIFO TTLIN

	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 1;//Cycl mode
	
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	
	S32 InStatus;
	ULONG msTimeout = 0; //       10 .

	Enable = 1;
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_ENABLE, &Enable); //   TTLIN	
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_ENABLE, &Enable); //   TTLOUT

	//int fl_break = 0;
	int loop = 0;
	int ii;

	printf("Hit any key to abort...\n");
	//while(!fl_break & !_kbhit())
	for (ii=0;;ii++)
	{
		status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
		
		if( BRD_errcmp(status, BRDerr_OK ))
		{
			BRDctrl_StreamCBufState strm;
			

			status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_FIFOSTATUS, &InStatus);

			BRD_ctrl(g_hTtlIn, 0, BRDctrl_STREAM_CBUF_STATE, &strm );

			sInPtr = (U32*)buf_dscr_in.ppBlk[strm.blkNum];
			CheckBuffer( sInPtr, samplesCnt );

			loop++;
		}	
		if (!(ii%0x1000)) 
			printf( "LOOP [0x%x] err:%d\r" , loop,g_errCnt );
		
		if (_kbhit())
			break;
	}
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
	
	Enable = 0;
	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_ENABLE, &Enable); //   TTLOUT
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_ENABLE, &Enable); //   TTLIN	

	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_TTLOUT_FIFORESET, NULL); //  FIFO TTLOUT
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_TTLIN_FIFORESET, NULL); //  FIFO TTLIN

	status = BRD_ctrl(g_hTtlOut, 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr_out);
	delete[] buf_dscr_out.ppBlk;
	status = BRD_ctrl(g_hTtlIn, 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr_in);
	delete[] buf_dscr_in.ppBlk;	
	
	getch();
	printf("Hit any key to exit\n");
	while( !_kbhit() );

	return status;
}

int _tmain(int argc, _TCHAR* argv[])
{
	char *iniFileName = "ex_ttl.ini";
	S32 err = 0;
	
	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); //     :     
	BRD_init( 0, 0 );
	
	ReadIniFile(iniFileName);

	hBrd = BRD_open( 1, BRDopen_SHARED, 0);

	if( hBrd <= 0 )
		return 1;

	printf( "open: OK\n" );
	
	U32 mode = BRDcapt_EXCLUSIVE;
	g_hTtlIn = BRD_capture(hBrd, 0, &mode, "TTLIN0", 10000);
	g_hTtlOut = BRD_capture(hBrd, 0, &mode, "TTLOUT0", 10000);

	if( (g_hTtlOut <= 0) || (g_hTtlIn <= 0) )
		return 1;

	printf( "capture: OK\n" );

	SetExamParam();

	printf( "setup: OK\n" );

	switch( g_MUParam.aMODE )
	{
	case 0:
		TestInOutCPU();
		break;
	case 1:
		TestInOutDMA();
		break;
	}
	BRD_release(g_hTtlIn,0); //   
	BRD_release(g_hTtlOut,0); //   
	BRD_close(hBrd); //  
	printf( "exit: OK\n" );

	return 0;
}

