//********************************************************
//
// Example Application of BRD_xxx functions for BASEDDS service.
//
// (C) InSys by Sklyarov A. Mar, 2007
//
//=********************************************************


#include	<conio.h>
#include	<stdio.h>
#include	<tchar.h>
#include	<ctype.h>
#include	<windows.h>
#include	<dos.h>

#include	"brd.h"
#include	"ctrlstrm.h"
#include	"CtrlDds.h"
#include	"CtrlCmpSC.h"
#define PI2   6.2831853071795864
#define		kSpace	0x3920

const U16 PLD_CFG_TAG	= 0x0500; // tag of PLD

BRD_Handle hBaseDds;

void DisplayError(S32 status, TCHAR* cmd_str);
bool ReadIniFile( char *pFileName );
S32	 PutDataToSrv(BRD_Handle handle, BRD_ServList* srv, int idx);
S32  SetBaseDds(BRD_Handle handle);
typedef struct 
{
	U32		RefClockSource;		// 1-internal, 0-external
	double	RefClockValue;		// (Hz)
	double  OutputFreq;			// (Hz)
	U32		LengthStb;			// (clock)
	U32		PolarityStb;		// 1-positiv, 0-negative
	U32		DelayStb;			// (clock)
	U32		PeriodStb;			// (clock)
	U32		NumberStb;			// Number out strobes
	U32		ContStb;			// 1-continuous out strobes
	U32		StartStb;			// 1- out stb, 0 - not out stb
	U32		StartSource;
	U32		StartInverse;
	double	ThresholdComp1;
} DDS_PARAM;
DDS_PARAM   g_DdsParam=
{
 	1,				// RefClockSource: 1-internal, 0-external
	19200000.0,		// RefClockValue (Hz)
	120000000.0,	// OutputFreq (Hz)
 	1000,			// LengthStb (clock)
	1,				// PolarityStb 1-positiv, 0-negative
	100,			// DelayStb (clock)
	10000,			// PeriodStb (clock)
	1,				// NumberStb
	0,				// ContStb
	1,				// StartStb
	0,				// StartSource;
	0,				// StartInverse;
	1.0				// ThresholdComp1;
};
//=****************** ReadIniPrepare **********************
//=********************************************************
typedef struct {char section[14]; int format;void *ptr; char title[20]; } TReadIniEntry;
static TReadIniEntry    iniEntry[] =
{
	{"Option", 0, (void*)&g_DdsParam.RefClockSource, "RefClockSource" },
	{"Option", 2, (void*)&g_DdsParam.RefClockValue, "RefClockValue" },
	{"Option", 2, (void*)&g_DdsParam.OutputFreq, "OutputFreq" },
	{"Option", 0, (void*)&g_DdsParam.LengthStb, "LengthStb" },
	{"Option", 0, (void*)&g_DdsParam.PolarityStb, "PolarityStb" },
	{"Option", 0, (void*)&g_DdsParam.DelayStb, "DelayStb" },
	{"Option", 0, (void*)&g_DdsParam.PeriodStb, "PeriodStb" },
	{"Option", 0, (void*)&g_DdsParam.NumberStb, "NumberStb" },
	{"Option", 0, (void*)&g_DdsParam.ContStb, "ContStb" },
	{"Option", 0, (void*)&g_DdsParam.StartStb, "StartStb" },
	{"Option", 0, (void*)&g_DdsParam.StartSource, "StartSource" },
	{"Option", 0, (void*)&g_DdsParam.StartInverse, "StartInverse" },
	{"Option", 2, (void*)&g_DdsParam.ThresholdComp1, "ThresholdComp1" },
};


//=************************* main *************************
//=********************************************************
void main( int argc, char *argv[] )
{
	S32		status;
	ReadIniFile("\\exam_bdds.ini" );

	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); //     :     
	
	S32	DevNum;
	status = BRD_init("brd.ini", &DevNum); //  

	//   LID (   )
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_lidList(lidList.pLID, lidList.item, &lidList.itemReal);

	BRD_Info	info;
	info.size = sizeof(info);
	BRD_Handle handle[10];
	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		BRD_getInfo(lidList.pLID[iDev], &info); //    
		printf("Board: %s, DevID = 0x%x, RevID = 0x%x, Bus = %d, Dev = %d, Slot = %d.\n", 
			info.name, info.boardType >> 16, info.boardType & 0xff, info.bus, info.dev, info.slot);
		//handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_EXCLUSIVE, NULL); //     
		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_SHARED, NULL); //     
		if(handle[iDev] > 0)
		{
			BRD_PuList PuList[5];
			U32 ItemReal;
			status = BRD_puList(handle[iDev], PuList, 5, &ItemReal); //    
			if(ItemReal <= 5)
			{
				for(U32 j = 0; j < ItemReal; j++)
				{
					printf("Programable unit %d: %s, Id = %d, Code = %x, Attr = %x.\n",
									j, PuList[j].puDescription, PuList[j].puId, PuList[j].puCode, PuList[j].puAttr);
				}
			}
			BRD_ServList srvList[10];
			status = BRD_serviceList(handle[iDev], 0, srvList, 10, &ItemReal);
			if(ItemReal <= 10)
			{
				for(U32 j = 0; j < ItemReal; j++)
				{

					printf("Service %d: %s, Attr = %X.\n",
									j, srvList[j].name, srvList[j].attr);
				}
			}

			U32 iSrv;
			for(iSrv = 0; iSrv < ItemReal; iSrv++)
			{
				if(!strcmp(srvList[iSrv].name, "BASEDDS0"))
					status = PutDataToSrv(handle[iDev], &srvList[iSrv], iDev * ItemReal + iSrv);
			}
			if(hBaseDds>0)BRD_release(hBaseDds,0); //   
			status = BRD_close(handle[iDev]); //   
			printf("\nBRD_close: OK\n");
		}
	}
	delete lidList.pLID;
	status = BRD_cleanup();
	printf("BRD_cleanup: OK\n");
	printf("Press any key for leaving program...\n");
	_getch();
}

//=****************** DisplayError ****************************
//=************************************************************
void DisplayError(S32 status, TCHAR* cmd_str)
{
	S32	real_status = BRD_errext(status);
	TCHAR msg[255];
	switch(real_status)
	{ 
	case BRDerr_OK:
		sprintf_s(msg, "%s: BRDerr_OK\n", cmd_str);
		break;
	case BRDerr_BAD_MODE:
		sprintf_s(msg, "%s: BRDerr_BAD_MODE\n", cmd_str);
		break;
	case BRDerr_INSUFFICIENT_SERVICES:
		sprintf_s(msg, "%s: BRDerr_INSUFFICIENT_SERVICES\n", cmd_str);
		break;
	case BRDerr_DDS_INVALID_WRRDREG:
		sprintf_s(msg, "%s: BRDerr_DDS_INVALID_WRRDREG\n", cmd_str);
		break;
	default:
		sprintf_s(msg, "%s: Unknown error\n", cmd_str);
		break;
	}
	printf(msg);
}

//=************************** ReadIniFile ********************
//=************************************************************
bool    ReadIniFile( char *pFileName )
{
	TCHAR Buffer[128];
	TCHAR iniFilePath[MAX_PATH];
	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);

	_tcscat_s(iniFilePath, pFileName);
    for(int i=0; i<sizeof(iniEntry)/sizeof(iniEntry[0]); i++ )
	{
		GetPrivateProfileString(iniEntry[i].section, iniEntry[i].title, "0", Buffer, sizeof(Buffer), iniFilePath);
		switch(iniEntry[i].format){
			case 0:	*(int*)iniEntry[i].ptr=atoi(Buffer);break;
			case 1:	*(float*)iniEntry[i].ptr=(float)atof(Buffer);break;
			case 2:	*(double*)iniEntry[i].ptr=atof(Buffer);break;
			case 3:	*(int*)iniEntry[i].ptr=atoi(Buffer);break;
 
		}
	}
	return true;
}
//=******************** PutDataToSrv *****************************
//=************************************************************
S32 PutDataToSrv(BRD_Handle handle, BRD_ServList* srv, int idx)
{
	S32	status;
	U32 mode = BRDcapt_EXCLUSIVE;

	hBaseDds = BRD_capture(handle, 0, &mode, srv->name, 10000);
	if(mode == BRDcapt_EXCLUSIVE) printf("BASEDDS0 Capture mode: EXCLUSIVE\n");
	if(mode == BRDcapt_SPY)	printf("BASEDDS0 Capture mode: SPY\n");
	if(hBaseDds > 0)
		status = SetBaseDds(hBaseDds); //   Dds
	return status;
}

//=******************* SetBaseDds *****************************
//=************************************************************

S32 SetBaseDds(BRD_Handle handle)
{
	S32		status;

	ULONG master=BRDims_SINGLE;
	status = BRD_ctrl(handle, 0, BRDctrl_DDS_SETMASTER, &master);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_DDS_SETMASTER:  master= %d\n",master);
	else
		DisplayError(status, "BRDctrl_DDS_SETMASTER");

	BRD_ClkMode clkMode;
	clkMode.src=g_DdsParam.RefClockSource;
	clkMode.value=g_DdsParam.RefClockValue;
	status = BRD_ctrl(handle, 0, BRDctrl_DDS_SETCLKMODE, &clkMode);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_DDS_SETCLKMODE: src= %d value = %.2f\n",clkMode.src,clkMode.value);
	else
		DisplayError(status, "BRDctrl_DDS_SETCLKMODE");	
	BRD_OutFreq  outFreq;
	outFreq.Freq=g_DdsParam.OutputFreq;
	outFreq.CPCurrentScale=1; //!!!
	outFreq.DividerM=1; //!!!
	status = BRD_ctrl(handle, 0, BRDctrl_DDS_SETOUTFREQ, &outFreq);

	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_DDS_SETOUTFREQ: OutputFreq   = %.2f\n",g_DdsParam.OutputFreq);
	else
		DisplayError(status, "BRDctrl_DDS_SETOUTFREQ");
	status = BRD_ctrl(handle, 0, BRDctrl_DDS_GETOUTFREQ, &outFreq);
	//----------------------- Set StartMode ------------------------
	BRD_StartMode  startMode;
		
	startMode.startSrc= g_DdsParam.StartSource;
	startMode.startInv= g_DdsParam.StartInverse;
	startMode.trigOn= 1;
	startMode.trigStopSrc= 0;
	startMode.stopInv= 0;
	startMode.reStartMode=0;

	status = BRD_ctrl(handle, 0, BRDctrl_DDS_SETSTARTMODE, &startMode);
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("BRDctrl_DDS_SETSTARTMODE: startSrc    = %d\n",startMode.startSrc);
		printf("                          startInv    = %d\n",startMode.startInv);
	}
	else
		DisplayError(status, "BRDctrl_DDS_SETSTARTMODE");

	BRD_CmpSC cmp_sc;
	cmp_sc.src=0;
	cmp_sc.thr[0]=g_DdsParam.ThresholdComp1;
	cmp_sc.thr[1]= g_DdsParam.ThresholdComp1;

	status = BRD_ctrl(handle, 0, BRDctrl_CMPSC_SET, &cmp_sc);
	if(BRD_errcmp(status, BRDerr_OK))
	{
		printf("BRDctrl_CMPSC_SET: sc.src      = %d\n",cmp_sc.src);
		printf("                   cmp_sc.thr[]= %f\n",cmp_sc.thr[0]);
                
	}else
		DisplayError(status, "BRDctrl_CMPSC_SET");

	BRD_StbMode stbMode;
	stbMode.Length=g_DdsParam.LengthStb;
	stbMode.Polarity=g_DdsParam.PolarityStb;
	stbMode.Delay=g_DdsParam.DelayStb;
	stbMode.Period=g_DdsParam.PeriodStb;
	stbMode.Number=g_DdsParam.NumberStb;
 	stbMode.ContStb=g_DdsParam.ContStb;


 	status = BRD_ctrl(handle, 0, BRDctrl_DDS_SETSTBMODE, &stbMode);
	if(BRD_errcmp(status, BRDerr_OK))
	{    
		printf("BRDctrl_DDS_SETSTBMODE: LengthStb    = %d\n",stbMode.Length);
		printf("                        PolarityStb  = %d\n",stbMode.Polarity);
		printf("                        DelayStb     = %d\n",stbMode.Delay);
		printf("                        PeriodStb    = %d\n",stbMode.Period);
		printf("                        NumberStb    = %d\n",stbMode.Number);
		printf("                        ContStb		 = %d\n",stbMode.ContStb);
		printf("                        StartStb     = %d\n",g_DdsParam.StartStb);
	} 
	else
		DisplayError(status, "BRDctrl_DDS_SETSTBMODE");

    if(g_DdsParam.StartStb==1)
	{
		printf("Press any key for start !\n");
		_getch();
  		status = BRD_ctrl(handle, 0, BRDctrl_DDS_SETSTBMODE, &stbMode);
    	status = BRD_ctrl(handle, 0, BRDctrl_DDS_STARTSTROBE, NULL);
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_DDS_STARTSTROBE: StartStb\n");
		else
			DisplayError(status, "BRDctrl_DDS_START");
	}

	return status;


	return 0;
}

//=************************************************************
// End of file
//
